# Implementation du probleme du manege a l'aide des semaphores
# Marc Michaud

require 'thread'
require 'counting_semaphore.rb'
srand
$n = 11
$c = 5
$t = 5

$semPlaceLibres = CountingSemaphore.new($c)
$semFinManege = CountingSemaphore.new
$semVoiturePleine = CountingSemaphore.new

def voiture()
  while (true)
    #puts "remplissage voiture"
    for i in 1..$c
      $semVoiturePleine.wait
    end
    puts "manege demarre"
    for i in 1..$t
      sleep 0.2
      puts "Tour : " + i.to_s
    end
    puts "manege arrete"
    for i in 1..$c
      $semFinManege.signal
    end
  end
end

def passager (x)
  while (true)
    $semPlaceLibres.P
    $semVoiturePleine.V
    puts "passager " + x.to_s + " s'assoit"
    $semFinManege.P
    puts "passager " + x.to_s + " sort"
    $semPlaceLibres.V
  end
end


threads=[]
for i in 1..$n
  threads[i-1]= Thread.new {passager(i)}  
end
thread_voiture= Thread.new {voiture}
for i in 0..4
  threads[i].join
end
thread_voiture.join
